#!/usr/bin/env ruby
## -*- mode: Ruby; TAB: 4 -*-
###############################################################################
## Copyright  1998-99 Klaus Alexander Seistrup @ Magnetic Ink, Copenhagen, DK.
##
## QTime -- Display time as English sentence.
##
## Author  : 1998 Klaus Alexander Seistrup <kseis@magnetic-ink.dk>
## Created : Sunday, 20th December 1998
## @(#) $Id: qtime.rb,v 1.4 1999/07/15 15:26:08 kseis Exp $
##
## My first program in Ruby. :-)
##
## This program is free software; you can redistribute it and/or modify it
## under the terms of the GNU General Public License as published by the Free
## Software Foundation; either version 2 of the License, or (at your option)
## any later version.
##
## This program is distributed in the hope that it will be useful, but with-
## out any warranty; without even the implied warranty of merchantability or
## fitness for a particular purpose.  See the GNU General Public License for
## more details.
##
## You should have received a copy of the GNU General Public License along
## with this program; if not, write to the Free Software Foundation, Inc.,
## 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
##
## Ruby is available from <ftp://ftp.netlab.co.jp/pub/lang/ruby/>
##                   and <http://www.netlab.co.jp/ruby/>
###############################################################################
##
## HISTORY:
##
##		15-Jul-1999:
##
##			Kindly modularized by gotoken@math.sci.hokudai.ac.jp (Goto
##			Kentaro) who also invites to join the Ruby mailing list:
##
##				<URL:http://www.netlab.co.jp/ruby/#maillist>
##
###############################################################################

module QTime
  HR = %w(twelve one two three four five six seven eight nine ten eleven)
  MN = ["", "five ", "ten ", "a quarter ", "twenty ", "twenty-five ", "half "]
  NY = ["nearly ", "almost ", "", "just after ", "after "]
  UP = ["to ", "", "past "]

  def secs_since_midnight (now = Time.now)
    (now - Time.local (now.year, now.month, now.day)).to_i
  end

  def qt (time = Time.now)
    adj_mins	= (secs_since_midnight (time) + 30) / 60 + 27
    hours		= (adj_mins / 60) % 12
    minutes		=  adj_mins % 60
    almost		=  minutes % 5
    divisions	= (minutes / 5) - 5
    to_past_idx	= 1 + (divisions <=> 0)

    "It's " +
      [NY[almost], MN[divisions.abs], UP[to_past_idx], HR[hours]].join +
      if divisions.zero? then " o'clock" else "" end + "."
  end

  def qtime (time = Time.now)
    print (qt (time), "\n")
  end

  module_function :secs_since_midnight, :qt, :qtime
end

if __FILE__ == $0
	QTime::qtime ()
end

## Soli Deo Gloria ############################################################
